// fronta2.cpp
#include <iostream>
#include <conio.h>
using namespace std;
template <class Typ> class Fronta{
  Typ *f;
  int zac,max,z,k,pocet;  
public:
  Fronta(int n)                   // konstruktor
  {
    max=n;
    f=new Typ[max];               // alokace pameti
    z=1;k=1;pocet=0;
  }
  ~Fronta(){free(f);}             // destruktor
  void init() {z=1;k=1;pocet=0;}  // inicializace zasobniku
  void vloz(Typ x);               // vlozeni objektu do fronty 
  Typ vezmi();                    // vyjmuti objektu z fronty
};
// vlozeni objektu x
template <class Typ> void Fronta <Typ>::vloz(Typ x)
{
  if (pocet==max)
     { cout << "Fronta je plna.\n"; system("PAUSE");
       return;
     }
  f[k++]=x; if (k>max) k=1; pocet++;
}
// vyjmuti objektu
template <class Typ> Typ Fronta<Typ>::vezmi()
{
  if (pocet==0)
  {
    cout << "Fronta je prazdna.\n"; system("PAUSE");
    return 0;
  }
  zac=z; if (++z>max) z=1; return f[zac];
}
// ukazka 
int main()
{
  Fronta<char> s1(5),s2(5);
  Fronta<double> d1(5);
  int i;
  s1.init(); s2.init(); d1.init();
  s1.vloz('a'); s2.vloz('x');
  s1.vloz('b'); s2.vloz('y');
  s1.vloz('c'); s2.vloz('z');
  d1.vloz(1.1); d1.vloz(2.2); d1.vloz(3.3);
  for (i=0;i<3;i++)
    cout <<s1.vezmi() << " " 
         <<s2.vezmi() << " " <<d1.vezmi() <<"\n";
  system("PAUSE");
  return 0;       
}
