//Nelinearni rovnice P(x)=0, kde P(x) je polynom
//metodou bisekce

#include <iostream>
#include <stdlib.h>
using namespace std;

double abs(double a)
{
	if (a<0) return -a; else return a;
}
double polynom(double koef[], int n, double a)
{
	// Hornerovo schema pro urceni hodnoty polynomu P(x) pro x=a
	// n stupen polynomu P(x) - max.20, koef[] koeficienty polynomu
	double h;
	int i;
	h=koef[0];
	for(i=1;i<=n;i++)
		h=a*h+koef[i];
	return h;
}

int main()
{
	double a,b;           // meze intervalu, ve kterem hledame reseni
	double c,d;           // hodnoty P(a), P(b)
	double eps;           // akceptovatelna chyba
	double koef[20];      // koeficienty polynomu
	double e,s;
	int i,n;
cti:cout << "Zadejte stupen polynomu:\n";
	cin >> n;
	if (n>20)
	{ cout << "Stupen musi byt max.20!\n"; goto cti; }
	cout << "Zadejte koeficienty polynomu\n";
	for(i=0;i<=n;i++)
		cin >> koef[i];
cint:	cout << "Zadejte zacatek intervalu: ";
	cin >> a;
	cout << "\nZadejte konec intervalu: ";
	cin >> b;
	c=polynom(koef,n,a); cout << "c=" << c << endl;
	d=polynom(koef,n,b); cout << "d=" << d << endl;
	if(c==0) {cout << "\nReseni je:" << a;
    system("PAUSE"); return 0;}
	if(d==0) {cout << "\nReseni je:" << b;
    system("PAUSE");  return 0;}
	if((c*d)>0) 
       {
          cout << "\nV danem intervalu nemusi existovat reseni\n"; 
          goto cint; 
       }
	cout << "\nZadejte pripustnou chybu: ";
	cin >> eps;
	cout <<"\n";
	while (abs(a-b) > eps)
	{
		s = (a+b)/2; e=polynom(koef,n,s); 
        cout << "s=" << s << " e=" << e << endl;
		if(e==0) 
        {
           cout << "\nResenim je:" << s << endl;
           system("PAUSE");  
           return 0;
        }
		if (e*c < 0) b=s;
		else a=s;
	} // konec while
	s=(a+b)/2;
	cout << "\nResenim je: " << s << "  "; 
    system("PAUSE"); return 0;
}

