// gauss.cpp
#include <iostream>
#include <math.h>
using namespace std;

const int N=4;
double x[N];
double a[N][N+1]=
{
  {1, 1, 1, 1, 1},
  {2, 2, 3, 1, 1},
  {2, 4, 4, 3, 5},
  {2, 5, 5, 1, 5}
};

int gauss(double a[N][N+1], double x[N])
{
  int max,i,j,k;
  int u,v;
    for(u=0; u<N; u++)                // kontrolni vypis zadane matice 
       {for (v=0; v<N+1; v++)
          cout << a[u][v] << " ";
        cout << endl;
       }
  double pom;
  // eliminace 
  for(i=0; i<N; i++)                  
  {
    max=i;
    for(j=i+1; j<N; j++)
      if(fabs(a[j][i])>fabs(a[max][i]))
        max=j;
    cout << "vymena radku " << i << " a " << max << endl;  
    if (i!=max)  
    for(k=i; k<N+1; k++)              // vymena radku 
    {
      pom=a[i][k];
      a[i][k]=a[max][k];
      a[max][k]=pom;
    }
    cout << "Upravena matice:" << endl;
    for(u=0; u<N; u++)                // kontrolni vypis upravene matice 
       {for (v=0; v<N+1; v++)
          cout << a[u][v] << " ";
        cout << endl;
       }
    if(a[i][i]==0)
      return 0;                       // soustava je singularni!
    for(j=i+1; j<N; j++)
      for(k=N; k>=i; k--)             // nasobeni a soucet radku
        a[j][k]=a[j][k]-a[i][k]*a[j][i]/a[i][i]; 
  }
// zptn chod
  x[j]=0;
  for(int j=N-1; j>=0; j--)
  {
    pom=0;
    for(int k=j+1; k<N; k++)
      pom=pom+a[j][k]*x[k];
    x[j]=(x[j]+a[j][N]-pom)/a[j][j];
  }
  return 1;                                      // OK
}

int main()
{
  if(!gauss(a,x))
    cout << "Soustava (1) je singularni!\n";
  else
  {
    cout << "Reseni:\n";
    for(int i=0;i<N;i++)
      cout << "x["<<i<<"]="<<x[i] << endl;
  }
  system("PAUSE");
  return 0;
}

