// romberg.cpp
#include <iostream>
#include <math.h>
using namespace std;
#define MAX 6
#define HODNOT 16
// tabulka 16 hodnot funkce y=f(x) pro hodnoty x ponaje 
// x=0 s krokem 0.05 az do x=0.8
double y[17]={1.0,1.051271,1.105171,1.161834,1.221403,
               1.284025,1.349859,1.419068,1.491825,1.568312,
               1.648721,1.733253,1.822119,1.915541,2.013753,
               2.117,2.225541}; 
int index, dalsi;  
double lich(double odkud, double kam, int useku)
{
    // lichobeznikovy vzorec
    double pom,krok;
    index=0;
    dalsi=HODNOT/useku;
    krok=(kam-odkud)/useku;
    pom=y[index]/2;  
    index+=dalsi;
    while (index < HODNOT)
    {   
       pom+=y[index]; 
       index+=dalsi;
    }
    pom=(pom+y[index]/2)*krok;     
    return pom;
}
 
int main()
{
    double r[MAX];
    int i,k,useku;
    double pre ;
    for (i=1; i<MAX; i++)
        r[i]=1;
    cout << "Rombergovo schema\n"; 
    for (k=1; k<MAX; k++)
    {
        for (i=1; i<=k; i++)
        {
            if (i==1)
            {
                pre=r[i];
                useku=(int)pow(2,k-1);          
                r[i] = lich(0,0.8,useku);    
                                  // funkce pro lichobeznikovy vzorec 
            }                                // integrace od 0 do 0.8 
            else
            {
                r[k]=(pow(4,i-1)*r[i-1]-pre)/(pow(4,i-1)-1); 
                pre=r[i];
                r[i]=r[k];  
            }
         }
         for (i=1; i<=k; i++)
         {
            cout.width(10);
            cout << r[i] << "  "; 
         }
         cout << endl;
    }
    system("PAUSE");
    return 0;
}
