// zjednoduseny Boyer-Mooreuv algoritmus pro vyhledani vzoru v textu
#define MAX_ABC 26  // pocet znaku angl.abecedy
#include <iostream>
#include <string> 
#include <conio.h>   
using namespace std;

void vposuv(char *v,int posuv[])
{
   int i,m;
   m=strlen(v); 
   for (i=0; i<MAX_ABC; ++i)
      posuv[i] = m;
   for (i=0; i<m-1; ++i)
      posuv[v[i]-97] = m-i-1;
   for (i=0; i<MAX_ABC; ++i)
      cout << posuv[i] << " ";
   cout << endl;
}
 
void hledej(char *v, char *t)
{
   int i,j,m,n,posuv[MAX_ABC];
   m=strlen(v); n=strlen(t);
 
   /* priprava */
   vposuv(v,posuv);
 
   /* hledani */
   j=0;
   while (j<=n-m)
   {
      for (i=m-1; i>=0 && v[i] == t[i+j]; --i);
      if (i<0)
      {
         cout << "vzor je na pozici: " << j << endl;
         j+=m;
      }
      else
         j=j+posuv[t[i+j]-97]-m+1+i; 
   }
}

int main()
{
  int i;  
  char *text="abrakadabraka",*vzorek="rak";
  hledej(vzorek,text);
  system("PAUSE");
  return 0;
}
