/* ExtremCest.c                               */
/* hledani extremalnich cest v acyklickem     */
/* orientovanem grafu                         */
/* program hleda nejdelsi cestu, provedeme/li */
/* zmeny podle komentaru, pak nejkratsi       */
/* nevyuzivam u poli slozky s indexem 0       */
#define HRAN 200
#define UZLU 26 
#include <stdio.h>

int main()
{
	int uzlu,hran;
	int ch,i,j,k,pocet;
	/* v[i] vychozi uzel i-te hrany */
	int v[HRAN]={0,1,1,2,2,3,3,4,5,5,6,7,8};
    /* w[i] koncovy uzel i-te hrany */ 
    int w[HRAN]={0,2,3,4,5,5,6,8,8,7,7,9,9}; 
    /* d[i] delka i-te hrany */ 
    int d[HRAN]={0,3,3,3,2,3,2,2,6,4,3,2,1}; 
    uzlu=9; hran=12;
	int vzd[UZLU];	

	/* vlastni algoritmus pro urceni delky cesty z 1.uzlu */
	for (i=1;i<=uzlu;i++)
		vzd[i]=-1;        /* 10000, hledame-li nejkratsi cestu */
	k=1;                  /* cislo pocatecniho uzlu */
	vzd[k] = 0; ch=1; pocet=0;
	while((ch==1)&&(pocet<=hran))
	{
		ch = 0;
		for (i=1; i<=hran; i++)
		{
			if (vzd[w[i]] < vzd[v[i]] + d[i])  /* relaci zmenime na >, */ 
			{                            /* hledame-li nejkratsi cestu */
				vzd[w[i]] = vzd[v[i]] + d[i];
				ch = 1; pocet++;
			}
		}
	}
	if (pocet>hran)
       {printf("Graf neni acyklicky\n"); system("PAUSE"); return 1;}
    printf("vzdalenosti z pocatecniho uzlu do ostatnich:\n");
	for(i=1;i<=uzlu;i++)    
		printf("%d %d\n",i,vzd[i]);

	/* urceni cesty */
	j=9; /* cislo koncoveho uzlu */
	printf("Cesta vede pres uzly:\n");
	while (j != k)
	{
		for (i=1; i<=hran; i++)
		{
			if (w[i] == j) 
			{ 
				if (vzd[w[i]] - vzd[v[i]] == d[i])
				{
					j = v[i];
					printf ("%d %d \n",j,vzd[j]);
				}
			}
		} 
	}
	system("PAUSE");
	return 0;
}  




