
/* DelkyCest.c                             */
/* cte textovy soubor HRANY.TXT, ktery            */
/* obsahuje hrany grafu silnicni site             */
/* Pak cte textovy soubor mesta.txt, ktery        */
/* pro poradova cisla uzlu obsahuje nazvy mest    */

#define HRAN 200
#define UZLU 26 
#include <stdio.h>

int main()
{
	int uzlu,hran;
	int ch,i;
	struct hrana
	{ 
		int v1;		/* vstupni uzel hrany          */
		int w1;		/* vystupni uzel hrany         */
		int d1;		/* delka hrany                 */
	};
	struct hrana h;
	int v[HRAN]; int w[HRAN]; int d[HRAN];
	int vzd[UZLU];
	FILE *fp;
	FILE *fr;
	char *jmeno="mesta.txt";
	char m[UZLU][20];
	char s[20];		/* max.delka nazvu mesta je 20 */
	int j,k;		/* vychozi a koncovy uzel      */
	if ((fr=fopen(jmeno,"rt"))==NULL)
	{
		printf("Soubor nemohu otevrit\n");
		return 1;
	}
	j=0;
	if ((fp=fopen("HR.txt","rt"))==NULL)
	{
		printf("Soubor nemohu otevrit\n");
		return 1;
    }  
        do
	    {
		  fscanf(fp,"%d %d %d",&h.v1,&h.w1,&h.d1);
			v[j]=h.v1;w[j]=h.w1;d[j]=h.d1; j++;
	    }
        while (h.d1>0);
        hran=j-1;    
	for(i=0;i<hran;i++)
		printf("%d %d %d\n",v[i],w[i],d[i]);
	if (fclose(fr)==EOF)
	{
		printf("Soubor nemohu zavrit\n");
		return 1;
	}

	if ((fp=fopen(jmeno,"rt"))==NULL)
	{
		printf("Soubor nemohu otevrit\n");
		return 1;
	}
	for(i=0;i<UZLU;i++)
	{
		fscanf(fp,"%d %s",&j,&s);
		for(j=0; j<20; j++)
			m[i][j]=s[j];
	}
	uzlu=i;
	for(i=0;i<uzlu;i++)
		printf("%d %s\n",i,m[i]);
	if (fclose(fp)==EOF)
	{
		printf("Soubor nemohu zavrit\n");
		return 1;
	}

	/* hrany s opacnou orientaci */
	for (i=1; i <= hran; i++)
		{
			v[i + hran] = w[i];
			w[i + hran] = v[i];
			d[i + hran] = d[i];
		}
	hran=hran*2;
	printf("Zadejte cislo vychoziho mista\n");
	scanf("%d",&k);

	/* vlastni algoritmus pro urceni vzdalenosti z k-teho uzlu */
	for (i=0;i<uzlu;i++)
		vzd[i]=10000;
	vzd[k] = 0;
	do
	{
		ch = 0;
		for (i=1; i<hran; i++)
		{
			if (vzd[v[i]] > vzd[w[i]] + d[i])
			{
				vzd[v[i]] = vzd[w[i]] + d[i];
				ch = 1;
			}
		}
	}
	while (ch == 1);
	for(i=0;i<uzlu;i++)
		printf("%d %s %d\n",i,m[i],vzd[i]);

	/* urceni cesty */
	printf("zadej cislo koncoveho mista\n");
	scanf("%d",&j);
	printf ("%s  %d km\n",m[j],vzd[j]);
	while (j != k)
	{
		for (i=1; i<hran; i++)
		{
			if (v[i] == j) 
			{ 
				if (vzd[v[i]] - vzd[w[i]] == d[i])
				{
					j = w[i];
					printf ("%s %d km\n",m[j],vzd[j]);
				}
			}
		} 
	}
	system("PAUSE");
	return 0;
}  




