/* min_kostra.c */
/* nalezeni minimalni kostry - hladovy algoritmus */
#define HRAN 14
#define UZLU 8
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
int i,j,m,n,x;
/* Graf je zadan seznamem hran */
int U[HRAN]={0,0,0,1,1,1,1,2,3,3,4,4,5,5};
int V[HRAN]={1,2,7,2,7,3,5,3,4,5,5,6,6,7};
int D[HRAN]={3,6,3,3,3,4,5,3,5,4,4,4,3,6};
int K[UZLU];

int main()
{
	for (i=0;i<UZLU;i++)
	K[i]=i; /* na zacatku je kazdy uzel komponentou */

	/* setrideni seznamu hran podle ohodnoceni,    */
	/* aby nalezena kostra byla minimalni kostrou  */
	for (i=1;i<HRAN;i++)
	{
		for (j=(HRAN-1);j>=i;j--)
		{
			if (D[j-1] > D[j])
			{
				x=U[j-1]; U[j-1]=U[j]; U[j]=x;
				x=V[j-1]; V[j-1]=V[j]; V[j]=x;
				x=D[j-1]; D[j-1]=D[j]; D[j]=x;
			}
		}
	}

	for (i=0;i<HRAN;i++)
		printf ("%d %d %d\n",U[i],V[i],D[i]);

	/* nalezeni a vytisteni minimalni kostry       */
	printf("Minimalni kostra grafu:\n");
	for(i=0;i<HRAN;i++)
	{
		if (K[U[i]]!=K[V[i]])
		{
			printf("%d %d\n",U[i],V[i]);
			if (K[U[i]]<K[V[i]])
			{ m=K[U[i]]; n = K[V[i]]; }
			else
			{ m=K[V[i]]; n = K[U[i]]; }
			for (j=0;j<UZLU;j++) 
			if (K[j]==n)
				K[j]=m; 
		} 
	}
	system("PAUSE");
	return 0;
}       

