// Zasobnik2.cpp
#include <iostream>
using namespace std;
template <class Typ> class Zasobnik{
  Typ * zas;
  int v;                   // vrchol zasobniku
  int max;                 // velikost zasobniku
public:
  Zasobnik(int n)          // konstruktor
  {
    max=n;
    v=0;
    zas=new Typ[max];      // alokace pameti
  }
  ~Zasobnik(){free(zas);}  // destruktor
  void init() {v=0;}       // inicializace zasobniku
  void vloz(Typ ob);       // vlozeni objektu do zasobniku 
  Typ vezmi();             // vyjmuti objektu ze zasobniku
};
// vlozeni objektu
template <class Typ> void Zasobnik <Typ>::vloz(Typ ob)
{
  if (v==max)
     { cout << "Zasobnik je plny.\n"; system("PAUSE");
       return;
     }
  zas[v]=ob; v++;
}
// vyjmuti objektu
template <class Typ> Typ Zasobnik<Typ>::vezmi()
{
  if (v==0)
  {
    cout << "Zasobnik je prazdny.\n"; system("PAUSE");
    return 0;
  }
  return zas[--v];
}
// ukazka 
int main()
{
  Zasobnik<char> s1(10),s2(5);
  Zasobnik<double> d1(5);
  int i;
  s1.init(); s2.init(); d1.init();
  s1.vloz('a'); s2.vloz('x');
  s1.vloz('b'); s2.vloz('y');
  s1.vloz('c'); s2.vloz('z');
  d1.vloz(1.1); d1.vloz(2.2); d1.vloz(3.3);
  for (i=0;i<3;i++)
    cout <<s1.vezmi() << " " 
         <<s2.vezmi() << " " <<d1.vezmi() <<"\n";
  system("PAUSE");       
}
