/* BinTreeV.c */
/* vytvori binarni strom vyvazeny  */ 
/* a v nem rusi rovnez s vyvazenim */
#include <stdlib.h>
#include <stdio.h>
struct vrchol
{
	struct vrchol *levy, *pravy;
	int klic;
	int pocet;
	int bal;	 /* rozdil vysky praveho a leveho podstromu */
};
typedef struct vrchol uzel;
uzel *koren;	 /* koen stromu */
uzel *p,*q,*s;

	void vyvaz1(uzel **p,int *h)
	{   /* h=1 - leva vetev se zmensila */
		uzel *u,*v;
		short int b1,b2;
		switch ((*p)->bal)
			{
			case -1:
				(*p)->bal=0;
				break;
			case 0:
				(*p)->bal=1; *h=0;
				break;
			case 1: /* znovuvyvazeni */
				u=(*p)->pravy; b1=u->bal;
				if (b1>=0)
				{	/* jednoducha RR rotace */
                    printf ("jednoducha RR rotace\n");
					(*p)->pravy=u->levy; u->levy=*p;
					if (b1==0)
					{(*p)->bal=1; u->bal=-1; *h=0;}
					else
					{(*p)->bal=0; u->bal=0;}
					(*p)=u;
				}
				else	
				{	/* dvojita RL rotace */
				    printf ("dvojita RL rotace\n");
					v=u->levy; b2=v->bal;
					u->levy=v->pravy; v->pravy=u;
					(*p)->pravy=v->levy; v->levy=*p;
					(*p)->bal=(b2==1)?-1:0;
					u->bal=(b2==-1)?1:0;
					*p=v; v->bal=0;
				}
			}	/* konec switche */
		}		/* konec vyvaz1 */

	void vyvaz2(uzel **p,int *h)
	{	/* h=1 - prava vetev se zmensila */
		uzel *u,*v;
		short int b1,b2;
		switch ((*p)->bal)
			{
			case 1:
				(*p)->bal=0;
				break;
			case 0:
				(*p)->bal=-1; *h=0;
				break;
			case -1: /* znovuvyvazeni */
				u=(*p)->levy; b1=u->bal;
				if (b1<=0)
				{		/* jednoducha LL rotace */
                    printf ("jednoducha LL rotace\n");
					(*p)->levy=u->pravy; u->pravy=*p;
					if (b1==0)
					{(*p)->bal=-1; u->bal=1; *h=0;}
					else
					{(*p)->bal=0; u->bal=0;}
					(*p)=u;
				}
				else	
				{	/* dvojita LR rotace */
                    printf("dvojita LR rotace\n");
					v=u->pravy; b2=v->bal;
					u->pravy=v->levy; v->levy=u;
					(*p)->levy=v->pravy; v->pravy=(*p);
					(*p)->bal=(b2==-1)?1:0;
					u->bal=(b2==1)?-1:0;
					*p=v; v->bal=0;
				}
	 		} /* konec switche */
	} /* konec vyvaz2 */

	void smaz(uzel **r,int *h)
	{
		if((*r)->pravy!=NULL)
		{
			smaz(&((*r)->pravy),h);
			if(*h) vyvaz2(r,h);
		}
		else
		{
			q->klic=(*r)->klic; q->pocet=(*r)->pocet; 
			*r=(*r)->levy; *h=1;
		}
	}

	int zrus(int x, uzel **p, int *h)
	{
	if ((*p)==NULL)
		{ printf("klic neni ve stromu\n"); *h=0; }
	else
		if(x<(*p)->klic)
		{
			zrus(x,&((*p)->levy),h);
			if (*h) vyvaz1(p,h);
		}
		else
			if(x>(*p)->klic)
			{
				zrus(x,&((*p)->pravy),h);
				if(*h) vyvaz2(p,h);
			}
			else /* ted rusim  x=(*p)->klic */
			{
				q=(*p);
				if(q->pravy==NULL)
				{
					(*p)=q->levy; *h=1;
				}
				else
				if (q->levy==NULL)
				{
					(*p)=q->pravy; *h=1;
				}
				else
				{
					smaz(&(q->levy),h);
					if (*h)vyvaz1(p,h);
				}
			}
			return 0;
	}
int pridej(int x, uzel **p, int *h)	/* h=true - zvetseni vetve */
{
	uzel *q,*u;
	if (*p==NULL)
	{
		*p=(uzel*)malloc(sizeof(uzel));
		if (*p==NULL) return 1;
                *h=1;
		(*p)->levy=NULL; (*p)->pravy=NULL;
		(*p)->klic=x; (*p)->pocet=1; (*p)->bal=0;
		return 0;
	}
	else
	{
		if ((*p)->klic == x)
		{
			(*p)->pocet++; *h=0;
			return 0;
		}
		else
		{
			if((*p)->klic>x)
			{
				pridej(x,&((*p)->levy),h); 
				if (*h)	/* zvetsila se leva vetev */
				{
					switch ((*p)->bal)
					{
					case 1:
						(*p)->bal=0; *h=0; break;
					case 0:
						(*p)->bal=-1; break;
					case -1:
						u=(*p)->levy;
						if(u->bal==-1)
						{	/* jednoducha LL rotace */
                            printf ("jednoducha LL rotace\n");
							(*p)->levy=u->pravy;
							u->pravy=*p;
							(*p)->bal=0; *p=u;
						}
						else
						{	/* dvojita LR rotace */
							q=u->pravy;
							printf("dvojita LR rotace\n"); 
							u->pravy=q->levy;
							q->levy=u; (*p)->levy=q->pravy;
							q->pravy=*p;
							(*p)->bal=(q->bal==-1)?1:0;
							u->bal=(q->bal==1)?-1:0;
							*p=q;
						}
						(*p)->bal=0; *h=0;
					}
				}
			}
			else	/* p->klic<x */
			{
			    pridej(x,&((*p)->pravy),h);
				if (*h)	/* zvetsila se prava vetev */
				{
					switch ((*p)->bal)
					{
					case -1:
						(*p)->bal=0; *h=0;
						break;
					case 0:
						(*p)->bal=1;
						break;
					case 1:
						u=(*p)->pravy;
						if (u->bal == 1)
						{		/* jednoducha RR rotace */
                            printf ("jednoducha RR rotace\n");
							(*p)->pravy=u->levy; u->levy=*p;
							(*p)->bal=0; *p=u;
						}
						else	
						{		/* dvojita RL rotace */
							q=u->levy;
							printf ("dvojita RL rotace\n");
							u->levy=q->pravy; q->pravy=u;
							(*p)->pravy=q->levy; q->levy=*p;
							(*p)->bal=(q->bal==1)?-1:0;
							u->bal=(q->bal==-1)?1:0;
							*p=q;
						}
						(*p)->bal=0; *h=0;
					} 
				}
			}
		}
	}
	return 0;
}

void Tisk(uzel * p)
{
	if (p->levy!=NULL)
	Tisk(p->levy);
	if (p->pravy!=NULL)
	Tisk(p->pravy);
	printf("%d ",p->klic);
}

int main()
{
	int h,i,x;
	int pole[10]={4,5,7,2,1,3,6,9,8,10};
	int pole2[7]={6,3,2,10,9,8,7};
	koren=NULL;
	for (i=0; i<10; i++)
	{
		x = pole[i]; 
        printf("vkladam %d\n",x); 
		if (pridej(x,&koren,&h)==1)
		{
			printf("Nedostatek pameti\n");
			return 1;
		}
	}
		printf ("Vysledek pridavani:\n");
       	Tisk(koren);
		printf("\n");
		for(i=0;i<7;i++)
		{
			x=pole2[i]; printf("rusim %d\n ",x);
			zrus(x,&koren,&h);
			Tisk(koren);
			printf("\n");
		}
		Tisk(koren);
        system("PAUSE");  
	return 0;
}
