/* post_tree.c */
/* Prevod postfixove notace na binarni strom */                                      
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
struct uzel
{
	char Oper;
	double Cislo;
	struct uzel *levy,*pravy;
};
struct uzel *P[50];        /* zasobnik               */
struct uzel *Q;
int sp;                    /* ukazovatko v zasobniku */
void Tisk(struct uzel * Q)
{
/* vypis bin.stromu preorder - prefixova notace */
/*	if (Q->Oper == ' ')
		printf("%f ",Q->Cislo);
	else
		printf("%c ",Q->Oper); */
	printf("(");
	if (Q->levy!=NULL)                                            
	Tisk(Q->levy);
/* inorder - infixova notace, k ni je nutny vystup zavorek */
	if (Q->Oper == ' ')
		printf("%f ",Q->Cislo);
	else
		printf("%c ",Q->Oper); 
	if (Q->pravy!=NULL)
	Tisk(Q->pravy);
	printf(")");
/* postorder - postfixova notace */
/*	if (Q->Oper == ' ')
		printf("%f ",Q->Cislo);
	else
		printf("%c ",Q->Oper); */
}
int main()
{
	char radek[200];
	char s[10];
	char c;
	int i,j,k;
  	sp = 0;            /* inicializace zasobniku */
	for (i=0;i<200;i++)
	radek[i]=' ';
	for (j=0;j<10;j++)
		 s[j]=0;
	printf("Zadejte vyraz v postfixove notaci:\n");
       j=strlen(gets(radek)); 
	radek[j]='=';      /* zarazka */
	i=0;
zac: while(radek[i]==' ')
		 i++;
	 c=radek[i]; 
	 if(c=='=')
	 {
		sp--; Q=P[sp]; /* koren stromu */
	 Tisk(Q); getch(); return;
	 }
	 if(c!='.' && !isdigit(c))
	 {		   /* operator */
		 Q=(struct uzel*)malloc(sizeof(struct uzel));
		 if (Q!=NULL)
		 {
			 if ((c=='+') ||(c=='-') ||(c=='*') ||(c=='/'))
			 {
				 Q->Oper=c; Q->Cislo=0;
				 if (sp<2) 
				 {
					 printf("Zasobnik je prazdny"); getch();
					 return;
				 }
				 sp--;
				 Q->pravy=P[sp]; sp--; Q->levy=P[sp];
				 P[sp]=Q; sp++;
			 }
			 else
			 {
				 printf("Neznamy prikaz"); getch();
				 return;
			 }
		 }
		 else
		 {
			 printf("neni pamet!"); getch();
			 return;
		 }
	 }
		 else
	 {		 /* operand */
		 k=0;
		 while(radek[i]==' ')
		 i++;
		 while(isdigit(radek[i]))
		 {
			 s[k]=radek[i]; 
			 if (k < 9)
			 k++;
			 else
			 {
				 printf ("Dlouhy operand!\n"); getch();
				 return;
			 } 
			 i++;
		 }
		 if (radek[i]=='.') 
		 {
			 s[k]='.'; i++;
			 if (k < 9)
			 k++;
			 else
			 {
				 printf ("Dlouhy operand!\n"); getch();
			 	 return;
			 } 
			 while(isdigit(radek[i]))
			 {
				 s[k]=radek[i];
			 	 if (k < 9)
			 	 k++;
				 else
			 	 {
					 printf ("Dlouhy operand!\n"); getch();
			 		 return;
				 } 
				 i++;
			 }
		 }
		 Q=(struct uzel*)malloc(sizeof(struct uzel));
		 if (Q!=NULL)
		 {
			 Q->Cislo=atof(s);
			 Q->Oper=' ';
			 Q->levy=NULL; Q->pravy=NULL;
			 if (sp<49)
			 {
				 P[sp]=Q; sp++; 
			 } 
			 else
			 {
				 printf("Plny zasobnik"); getch();
				 return;
			 }
		 }
		 else
		 {
			 printf("Neni pamet"); getch();
			 return;
		 }
		 i--; 
	 }
	 i++;
	 goto zac;
	 return 0;
}
	
