/* projdi_do_sirky.c */
#include <stdio.h>
#include <conio.h>
#define UZLU 200
#define HRAN 500
/* Definice */
int uzlu;           /* pocet uzlu */
int hran;           /* pocet hran */
int oznac[UZLU];    /* pro prohledavani do sirky */              
int v[HRAN];        /* vstupni uzel hrany   */
int w[HRAN];        /* vystupni uzel hrany  */ 
int u[UZLU+1];      /* v poli indexuji od 0 */
int e[HRAN];        /* indexuji od 0 */
/* u a e tvori seznam nasledniku, v a w seznam hran */

/* fronta pro hledani do sirky */
int zac,kon;
int f[UZLU];        /* fronta */

void vloz (int x) 
{
    f[kon] = x;
    kon++;
}

int vezmi () 
{
    int x = f[zac];
    zac++;
    return x;
}
/* prochazeni do sirky */
int projdi (int start) 
{
    int i,j,k;
    zac = kon = 0;         /* inicializace fronty */
    vloz(start); oznac[start]=0;
    printf("%d\n",start);
    while (zac!=kon)       /* dokud fronta neni prazdna */
    {
	  j=vezmi();           /* vyber 1.otevreny uzel */ 
	  if (oznac[j]==0)
	  for (i=u[j]; i<u[j+1]; i++)
	  {
        k=e[i];            /* a jeho nasledniky  */      
	    if (oznac[k]==-1)  /* kteri jsou novi */ 
        {                 
		  vloz(k);         /* uloz do fronty  */ 
          oznac[k]=0;      /* a otevri        */ 
		  printf("%d\n",k);
	    }
      }
      oznac[j]=1;
    }
    return;
}

/* cteni vstupniho souboru */
void read_input_file() 
{
    int x,y,i,j,k;
    FILE * input;
    if ((input = fopen("hrany2.txt","rt"))==NULL)
      printf("nemohu otevrit\n");
    /* cte pocet uzlu a hran */
    fscanf(input,"%d %d",&uzlu,&hran);
    printf("uzlu=%d hran=%d\n",uzlu,hran);
    /* cte jednotlive hrany */
    for (i=0; i<hran; i++) 
    {
	  fscanf(input,"%d %d",&v[i],&w[i]);
    }
    fclose(input);
    /* setrideni seznamu hran podle vst.uzlu */
    for (i=0; i<hran; i++)
	{
		k=i; x=v[i]; y=w[i];
		for (j=i+1; j<hran; j++)
			if (v[j]<x)
			{
				k=j; x=v[j]; y=w[j];
			}
			v[k]=v[i]; v[i]=x; w[k]=w[i]; w[i]=y; 
	}                          						                         
	/* algoritmus pro seznam nasledniku */
	k=0; i=0; /* k je cislo uzlu, i index v e */
	for (j=0;j<uzlu+1;j++) u[j]=0;
	for (j=0;j<hran;j++)
	{
		if (v[j]==k)
		{
            e[i]=w[j]; i++;
        }
        else
        {
            k=v[j]; u[k]=i; 
            e[i]=w[j]; i++;
        }
	}
	for (j=k+1;j<uzlu+2;j++)
	u[j]=i; 
	for (j=1;j<uzlu+2;j++)
	   if (u[j]==0) u[j]=u[j+1]; 
    printf("seznam nasledniku:\n");
    printf("u: ");
    for (i=0; i<uzlu+1; i++) printf("%d ",u[i]);
    printf("\n");
    printf("e: ");
    for(i=0;i<hran;i++) printf("%d ",e[i]);
    printf("\nuzly\n");
}

int main () 
{
    read_input_file();
    int i;
    for (i=0; i<uzlu; i++) /* vsechny uzly */ 
	   oznac[i] = -1;      /* oznac jako nove */
    for (i=0; i<uzlu; i++) 
	   if (oznac[i]==-1) projdi(i); 
    system("PAUSE");
    return 0;
}

    
    
    

